
#include "fbgfx.bi"

const sx = 800, sy = 600, max = 50

const puzzlex = 200, puzzley = 240
const blx = 122, bly = 133
const brx = 104, bry = 113
const tlx = 118, tly = 129
const trx = 126, try = 155

type pic_type
  as fb.image ptr i
  as double x, y, yv
end type

dim shared as integer total, fc, downon
dim shared as integer mx, my, mb, pmx, pmy, pmb
dim shared as fb.image ptr bl, br, tl, tr
dim shared as pic_type pic(1 to max)

screenres sx, sy, 32

bl = imagecreate(blx, bly)
bload "bl.bmp", bl
br = imagecreate(brx, bry)
bload "br.bmp", br

tl = imagecreate(tlx, tly)
bload "tl.bmp", tl
tr = imagecreate(trx, try)
bload "tr.bmp", tr

do
  fc += 1
  
  pmx = mx
  pmy = my
  pmb = mb
  getmouse(mx, my,, mb)
  
  if (fc mod 200) = 0 and total < max then
    total += 1
    with pic(total)
      select case int(rnd * 4)
      case 0: .i = bl
      case 1: .i = br
      case 2: .i = tl
      case 3: .i = tr
      end select
      
      .x = rnd() * sx
      .y = -int(.i->height)
    end with
  end if
  
  'main collision
  for i as integer = 1 to total
    with pic(i)
      if i = downon then continue for
      .yv += .2
      .y += .yv
      if .y + .i->height > sy then .y = sy - .i->height
      
      for j as integer = 1 to total
        if i = j or j = downon then continue for
        if .x < pic(j).x and .x + .i->width < pic(j).x then continue for
        if .x > pic(j).x and .x > pic(j).x + pic(j).i->width then continue for
        
        if .y < pic(j).y and .y + .i->height > pic(j).y then
          .y = pic(j).y - .i->height
        end if
      next j
    end with
  next i
  
  if mb > 0 and pmb = 0 then
    for i as integer = 1 to total
      if mx < pic(i).x or mx > pic(i).x + pic(i).i->width then continue for
      if my < pic(i).y or my > pic(i).y + pic(i).i->height then continue for
      downon = i
      exit for
    next i
  end if
  if mb = 0 and pmb > 0 then downon = 0
  
  if downon > 0 then
    pic(downon).x += mx - pmx
    pic(downon).y += my - pmy
  end if
  
  if downon = 0 then
    for i as integer = 1 to total
      if pic(i).i <> bl then continue for
      for j as integer = 1 to total
        if pic(j).i <> br then continue for
        for k as integer = 1 to total
          if pic(k).i <> tl then continue for
          for l as integer = 1 to total
            if pic(l).i <> tr then continue for
            
            if abs(pic(j).x - pic(i).x - blx) > 20 then continue for
            if abs(pic(l).x - pic(k).x - tlx) > 20 then continue for
            if abs(pic(i).y - pic(k).y - tly) > 20 then continue for
            if abs(pic(j).y - pic(l).y - try) > 20 then continue for
            
            print "HO SNAP YOU WON IN " & fc & " FRAMES!!!"
            sleep()
            system()
          next l
        next k
      next j
    next i
  end if
  
  screenlock()
  cls()
  for i as integer = 1 to total
    with pic(i)
      put (.x, .y), .i, trans
    end with
  next i
  screenunlock()
  
  sleep(10, 1)
loop until inkey = chr(27)
